program dest;
uses Alg3, App, Drivers, Objects, Menus, Views, Dialogs, MsgBox,
  FParam, ViewText, Strcts, StdDlg, FlCopy, DestHpw32, HelpFile;

const
   cmAlgorithmDial = 1000;
   cmAlgorithmSelf = 1001;
   cmGameIndovinate = 1002;
   cmGameSelf = 1003;
   cmAbout = 1010;

   cmSaveHistory = 100;
   cmSaveCone = 101;
   cmHelp = 102;
   cmHelpIndex = 103;
   cmHelpOnHelp = 104;
   {cmPrevHelp = 105;}


type
  TMyApp = object(TApplication)
    K1, K2, A, B, C: LongInt;
    constructor Init;
    procedure HandleEvent(var Event: TEvent); virtual;
    procedure GetEvent(var Event: TEvent); virtual;
    function GetPalette: PPalette; virtual;
    procedure InitMenuBar; virtual;
    procedure InitStatusLine; virtual;
    procedure CloseAll;
  end;

constructor TMyApp.Init;
var Event: TEvent;
begin
  inherited Init;
  A := 7;
  B := 11;
  C := 333;
  K1 := 40;
  K2 := 30;
  RegisterHelpFile;
  DisableCommands([cmSaveHistory, cmSaveCone]);
  Event.What := evCommand;
  Event.Command := cmAbout;
  PutEvent(Event);
end;

procedure TMyApp.CloseAll;

  procedure CloseWin(P: PView); far;
  begin
    Message(P, evCommand, cmClose, nil);
  end;

begin
  DeskTop^.ForEach(@CloseWin);
end;

procedure TMyApp.HandleEvent(var Event: TEvent);

function MessageUnnactiveWindow: PDialog;
var
  R: TRect;
  Dlg: PDialog;
begin
R.Assign(14, 4, 68, 20);
New(Dlg, Init(R, ''));

R.Assign(1, 2, 53, 3);
Dlg^.Insert(New(PStaticText, Init(R, ' ᮫쭮  Windows  ⨢')));

R.Assign(1, 3, 53, 4);
Dlg^.Insert(New(PStaticText, Init(R, '३  ᪮ ')));

Dlg^.Options := Dlg^.Options + ofCentered;

Insert(Dlg);

MessageUnnactiveWindow := Dlg;

end;

procedure doAlgorithmSelf;
  var
    DataRec : record
      Field6 : LongInt;
      Field10 : LongInt;
      Field11 : LongInt;
      Field13 : LongInt;
      Field14 : LongInt;
    end;
var
  Alg: TGraphAlg;
  Oracle: PABCOracle;
  TargetFunction: PThresholdFunction;
  R: TRect;
  F: Text;
  W: PWindow;
  D: PDialog;

begin
  with DataRec do
  begin
    Field6 := K1;
    Field10 := K2;
    Field11 := A;
    Field13 := B;
    Field14 := C;
  end;
  D := MakeFunctionBigDialog;
  D^.HelpCtx := hcFunctionDialogBig;
  if ExecuteDialog(D, @DataRec) = cmOk then
  begin
    with DataRec do
    begin
      K1 := Field6;
      K2 := Field10;
      A := Field11;
      B := Field13;
      C := Field14;
    end;

    D := MessageUnnactiveWindow;
    DoneSysError;
    DoneEvents;
    {DoneVideo;}


    Assign(F, '');
    Rewrite(F);
    New(Oracle, Init(A, B, C));
    New(TargetFunction, Init);
    Alg.Init(K1, K2, Oracle, TargetFunction, @F);
    Alg.Run;
    Alg.Done;
    Close(F);
    Assign(F, '');
    Rewrite(F);
    with TargetFunction^ do
      Print3LongMatrix(F, Cone, Ostow, Incidence);
    Close(F);
    Dispose(TargetFunction, Done);
    Dispose(Oracle);

    {InitVideo;}
    InitEvents;
    InitSysError;
    D^.Close;
    CloseAll;
    EnableCommands([cmSaveHistory, cmSaveCone]);
    Redraw;

    R.Assign(0, 0, 27, 23);
    W := New(PTextWindow, Init(R, ''));
    W^.HelpCtx := hcHistory;
    InsertWindow(W);
    R.Assign(27, 0, 80, 23);
    W := New(PTextWindow, Init(R, ''));
    W^.HelpCtx := hcCone;
    InsertWindow(W);
  end;
end;

procedure DoAlgorithmDial;
var
  DataRec : record
    Field6 : LongInt;
    Field10 : LongInt;
  end;
var
  Alg: TGraphAlg;
  Oracle: PDialogOracle;
  TargetFunction: PThresholdFunction;
  R: TRect;
  F: Text;
  W: PWindow;
  D: PDialog;

begin
  with DataRec do
  begin
    Field6 := K1;
    Field10 := K2;
  end;
  D := MakeFunctionSmallDialog;
  D^.HelpCtx := hcFunctionDialogSmall;
  if ExecuteDialog(D, @DataRec) = cmOk then
  begin
    with DataRec do
    begin
      K1 := Field6;
      K2 := Field10;
    end;

    D := MessageUnnactiveWindow;
    DoneSysError;
    DoneEvents;
    {DoneVideo;}

    Assign(F, '');
    Rewrite(F);
    New(Oracle, Init);
    New(TargetFunction, Init);
    Alg.Init(K1, K2, Oracle, TargetFunction, @F);
    Alg.Run;
    Alg.Done;
    Close(F);
    Assign(F, '');
    Rewrite(F);
    with TargetFunction^ do
      Print3LongMatrix(F, Cone, Ostow, Incidence);
    Close(F);
    Dispose(TargetFunction, Done);
    Dispose(Oracle);

    {InitVideo;}
    InitEvents;
    InitSysError;
    D^.Close;
    CloseAll;
    EnableCommands([cmSaveHistory, cmSaveCone]);
    Redraw;

    R.Assign(0, 0, 27, 23);
    W := New(PTextWindow, Init(R, ''));
    W^.HelpCtx := hcHistory;
    InsertWindow(W);
    R.Assign(27, 0, 80, 23);
    W := New(PTextWindow, Init(R, ''));
    W^.HelpCtx := hcCone;
    InsertWindow(W);

  end;
end;

procedure doGameSelf;
  var
    DataRec : record
      Field6 : LongInt;
      Field10 : LongInt;
      Field11 : LongInt;
      Field13 : LongInt;
      Field14 : LongInt;
    end;
var
  Game: TGraphGame;
  Oracle: PABCOracle;
  TargetFunction: PThresholdFunction;
  R: TRect;
  F: Text;
  W: PWindow;
  D: PDialog;

begin
  with DataRec do
  begin
    Field6 := K1;
    Field10 := K2;
    Field11 := A;
    Field13 := B;
    Field14 := C;
  end;
  D := MakeFunctionBigDialog;
  D^.HelpCtx := hcFunctionDialogBig;
  if ExecuteDialog(D, @DataRec) = cmOk then
  begin
    with DataRec do
    begin
      K1 := Field6;
      K2 := Field10;
      A := Field11;
      B := Field13;
      C := Field14;
    end;

    D := MessageUnnactiveWindow;
    DoneSysError;
    DoneEvents;
    {DoneVideo;}

    Assign(F, '');
    Rewrite(F);
    New(Oracle, Init(A, B, C));
    New(TargetFunction, Init);
    Game.Init(K1, K2, Oracle, TargetFunction, @F);
    Game.Run;
    Game.Done;
    Close(F);
    Assign(F, '');
    Rewrite(F);
    with TargetFunction^ do
      Print3LongMatrix(F, Cone, Ostow, Incidence);
    Close(F);
    Dispose(TargetFunction, Done);
    Dispose(Oracle);

    {InitVideo;}
    InitEvents;
    InitSysError;
    D^.Close;
    CloseAll;
    EnableCommands([cmSaveHistory, cmSaveCone]);
    Redraw;

    R.Assign(0, 0, 27, 23);
    W := New(PTextWindow, Init(R, ''));
    W^.HelpCtx := hcHistory;
    InsertWindow(W);
    R.Assign(27, 0, 80, 23);
    W := New(PTextWindow, Init(R, ''));
    W^.HelpCtx := hcCone;
    InsertWindow(W);
  end;
end;

procedure DoGameIndovinate;
var
  DataRec : record
    Field6 : LongInt;
    Field10 : LongInt;
  end;
var
  Alg: TGraphGame;
  Oracle: PABCOracle;
  TargetFunction: PThresholdFunction;
  R: TRect;
  F: Text;
  W: PWindow;
  D: PDialog;
  A, B, C: LongInt;

begin
  with DataRec do
  begin
    Field6 := K1;
    Field10 := K2;
  end;
  D := MakeFunctionSmallDialog;
  D^.HelpCtx := hcFunctionDialogSmall;
  if ExecuteDialog(D, @DataRec) = cmOk then
  begin
    with DataRec do
    begin
      K1 := Field6;
      K2 := Field10;
    end;

    D := MessageUnnactiveWindow;
    DoneSysError;
    DoneEvents;
    {DoneVideo;}

    Assign(F, '');
    Rewrite(F);
    RandomCoefficients(K1, K2, A, B, C);
    New(Oracle, Init(A, B, C));
    New(TargetFunction, Init);
    Alg.Init(K1, K2, Oracle, TargetFunction, @F);
    Alg.Run;
    Alg.Done;
    Close(F);
    Assign(F, '');
    Rewrite(F);
    with TargetFunction^ do
      Print3LongMatrix(F, Cone, Ostow, Incidence);
    Close(F);
    Dispose(TargetFunction, Done);
    Dispose(Oracle);

    {InitVideo;}
    InitEvents;
    InitSysError;
    D^.Close;
    CloseAll;
    EnableCommands([cmSaveHistory, cmSaveCone]);
    Redraw;

    R.Assign(0, 0, 27, 23);
    W := New(PTextWindow, Init(R, ''));
    W^.HelpCtx := hcHistory;
    InsertWindow(W);
    R.Assign(27, 0, 80, 23);
    W := New(PTextWindow, Init(R, ''));
    W^.HelpCtx := hcCone;
    InsertWindow(W);

  end;
end;


procedure doAbout;

function MakeDialog : PDialog;
var
  Dlg : PDialog;
  R : TRect;
  Control : PView;

begin
R.Assign(14, 4, 68, 20);
New(Dlg, Init(R, ' ணࠬ'));

R.Assign(1, 2, 53, 3);
Control := New(PStaticText, Init(R, 'Dest'));
Dlg^.Insert(Control);

R.Assign(1, 3, 53, 4);
Control := New(PStaticText, Init(R, '⮤ ஢ ண 㭪権'));
Dlg^.Insert(Control);

R.Assign(1, 4, 53, 5);
Control := New(PStaticText, Init(R, '  Win32'));
Dlg^.Insert(Control);

R.Assign(1, 6, 53, 7);
Control := New(PStaticText, Init(R, '() 1998-2000, 2005, 2009 ..'));
Dlg^.Insert(Control);

R.Assign(1, 7, 53, 8);
Control := New(PStaticText, Init(R, '䥤 ⥬᪮   襩 '));
Dlg^.Insert(Control);

R.Assign(1, 8, 53, 9);
Control := New(PStaticText, Init(R, 'த᪨ 㤠⢥ 㭨'));
Dlg^.Insert(Control);

R.Assign(1, 9, 53, 10);
Control := New(PStaticText, Init(R, 'http://www.uic.nnov.ru/~zny'));
Dlg^.Insert(Control);

R.Assign(22, 12, 32, 14);
Control := New(PButton, Init(R, 'O~k~', cmOK, bfDefault));
Dlg^.Insert(Control);

Dlg^.SelectNext(False);
Dlg^.Options := Dlg^.Options + ofCentered;
MakeDialog := Dlg;
end;


begin
  ExecuteDialog(MakeDialog, nil);
end;

procedure doSaveHistory;
var
  aFile : String;
  W: PDialog;
begin
  aFile := '*.REP';
  W := New(PFileDialog, Init('*.REP', 'Save history', 'File name',
    fdOkButton, 0) ) ;
  W^.HelpCtx := hcSaveHistory;
  if Application^.ExecuteDialog(W, @aFile) <> cmCancel then
    FileCopy('', aFile);
end;

procedure doSaveCone;
var
  aFile : String;
  W: PDialog;
begin
  aFile := '*.REP';
  W := New(PFileDialog, Init('*.REP', 'Save cone', 'File name',
    fdOkButton, 0) );
  W^.HelpCtx := hcSaveCone;
  if Application^.ExecuteDialog(W, @aFile) <> cmCancel then
    FileCopy('', aFile);
end;

begin
  inherited HandleEvent(Event);
  if Event.What = evCommand then
  begin
    case Event.Command of
      cmAlgorithmDial: doAlgorithmDial;
      cmAlgorithmSelf: doAlgorithmSelf;
      cmGameSelf: doGameSelf;
      cmGameIndovinate: doGameIndovinate;
      cmSaveHistory: doSaveHistory;
      cmSaveCone: doSaveCone;
      cmAbout: doAbout;
    end;
  end;
end;

procedure TMyApp.InitMenuBar;
var
  R: TRect;
begin
  GetExtent(R);
  R.B.Y := R.A.Y + 1;
  MenuBar := New(PMenuBar, Init(R, NewMenu(
    NewSubMenu('~S~-', hcStart, NewMenu(
      NewSubMenu('~A~-', hcAlgorithm, NewMenu(
        NewItem('~D~- ਠ', '', kbNoKey, cmAlgorithmDial, hcAlgorithmDial,
        NewItem('~S~- ਠ', '', kbNoKey, cmAlgorithmSelf, hcAlgorithmSelf, nil))),
      NewSubMenu('~G~-', hcGame, NewMenu(
        NewItem('~1~', '', kbNoKey, cmGameIndovinate, hcGameIndovinate,
        NewItem('~2~', '', kbNoKey, cmGameSelf, hcGameSelf, nil))),
      NewItem('~X~-室', 'Alt-X', kbAltX, cmQuit, hcExit,
      nil)))),
    NewSubMenu('~R~-', hcReport, NewMenu(
      NewItem('~C~-࠭ `''', '', kbNoKey, cmSaveCone, hcSaveCone,
      NewItem('~H~-࠭ `''', '', kbNoKey, cmSaveHistory, hcSaveHistory,
      nil))),
    NewSubMenu('~H~-', hcHelpOnHelp, NewMenu(
      NewItem('~C~-맮 ࠢ', 'F1', kbF1, cmHelp, hcHelpOnHelp,
      NewItem('~I~-', 'Shift-F1', kbShiftF1, cmHelpIndex, hcIndex,
      NewItem('~O~- ࠢ', '', kbNoKey, cmHelpOnHelp, hcHelpOnHelp,
      NewItem('~A~- ணࠬ', '', kbNoKey, cmAbout, hcAbout,
      nil))))),
    nil))))));
end;

procedure TMyApp.InitStatusLine;
var
  R: TRect;
begin
  GetExtent(R);
  R.A.Y := R.B.Y - 1;
  New(StatusLine, Init(R,
    NewStatusDef(0, $FFFF,
      StdStatusKeys(
      NewStatusKey('~F1~ ', kbF1, cmHelp,
      NewStatusKey('', kbF10, cmMenu, nil))), nil)));
end;

procedure TMyApp.GetEvent(var Event: TEvent);
  function ContainsMouse(P: PView): Boolean;{$IFDEF PPC_BP}far;{$ENDIF}
  begin
    ContainsMouse := (P^.State and sfVisible <> 0) and P^.MouseInView(Event.Where);
  end;

var
  W: PWindow;
  HFile: PHelpFile;
  HelpStrm: PDosStream;
const
  HelpInUse: Boolean = False;
begin
  inherited GetEvent(Event);
{    BP   Program.GetEvent.
 fv   ,     }
   if StatusLine <> nil then
     if (Event.What and evKeyDown <> 0)
        or (Event.What and evMouseDown <> 0) and (FirstThat(@ContainsMouse) = PView(StatusLine))
     then
       StatusLine^.HandleEvent(Event);
{ }
  if ((Event.What = evCommand)
       and ((Event.Command = cmHelp) or (Event.Command = cmHelpIndex) or
        (Event.Command = cmHelpOnHelp)))
      or ((Event.What = evKeyDown) and (Event.KeyCode = kbF10))
      and not HelpInUse then
      begin
        DisableCommands([cmMenu, cmHelp]);
        HelpInUse := True;
        HelpStrm := New(PDosStream, Init('DESTHPw32.HLP', stOpenRead));
        HFile := New(PHelpFile, Init(HelpStrm));
        if HelpStrm^.Status <> stOk then
        begin
          MessageBox(#3'   䠩 "DESTHPw32.HLP".', nil,
            mfError + mfOkButton);
          Dispose(HFile, Done);
        end
        else
        begin
          if Event.Command = cmHelpIndex then
            W := New(PHelpWindow, Init(HFile, hcIndex))
          else if Event.Command = cmHelpOnHelp then
            W := New(PHelpWindow, Init(HFile, hcHelpOnHelp))
          else
            W := New(PHelpWindow, Init(HFile, GetHelpCtx));
          if ValidView(W) <> nil then
          begin
            ExecView(W);
            Dispose(W, Done);
            {InsertWindow(W);}
          end;
          ClearEvent(Event);
        end;
        HelpInUse := False;
        EnableCommands([cmMenu, cmHelp]);
      end;
end;

function TMyApp.GetPalette: PPalette;
const
  CNewColor = CAppColor + CHelpColor;
  CNewBlackWhite = CAppBlackWhite + CHelpBlackWhite;
  CNewMonochrome = CAppMonochrome + CHelpMonochrome;
  P: array[apColor..apMonochrome] of string[Length(CNewColor)] =
    (CNewColor, CNewBlackWhite, CNewMonochrome);
begin
  GetPalette := @P[AppPalette];
end;

var
  MyApp: TMyApp;

begin
  MyApp.Init;
  MyApp.Run;
  MyApp.Done;
end.
