Unit Gauss;
Interface
Uses Strcts;

function LongMatrixGauss(A, F, Q, E: PLongMatrix; var det: LongInt): ShortInt;
{ 묨 ८ࠧﬨ  ப  A
   ⠭  ⮫殢 ਢ   쭮 : F*A = Q.
  ꥪ F, Q   㦥 ᮧ -- ,    뫮 -- 㤠 }

Implementation
Uses GCD;

function LongMatrixGauss(A, F, Q, E: PLongMatrix; var Det: LongInt): ShortInt;
const
  MinusOne: LongInt = -1;
var
  N, M, i, j, ii: Integer;
  b, b_ii, b_i, Alpha: LongInt;
begin

  N := A^.N;
  M := A^.M;

  if (F^.ReSize(N, N) <> 1) or (Q^.ReSize(N, M) <> 1)
    or (E^.ReSize(0, N) <> 1) then
  begin
    LongMatrixGauss := -2; { 墠⠥ }
    Exit;
  end;

  det := 1;

  { 塞 F 筮 楩 }
  b := 0;
  for i := 1 to N do
    for j := 1 to N do
      F^.PutItem(i, j, b);
  b := 1;
  for i := 1 to N do
    F^.PutItem(i, i, b);

  { Q := A }
  for i := 1 to N do
    for j := 1 to M do
    begin
      A^.GetItem(j, i, b);
      Q^.PutItem(i, j, b);
    end;

  LongMatrixGauss := 1; {஦ 砩}

  { ᭮ 横 ( ப) }
  i := 1;
  while i <= Q^.GetM do
  begin

    { 饬 㫥   i- ப  i-  M-  }
    j := i-1;
    repeat
      Inc(j);
      if j <= M then
        Q^.GetItem(i, j, b);
    until (j > M) or (b <> 0);
    if j > M then
    begin { ப 㫥}
      det := 0;
      Q^.DelRow(i);
      E^.InsThisRow(E^.GetM + 1, F^.TakeRow(i));
      LongMatrixGauss := 2; {஦ 砩}
      Continue; {᭮ 横  ப }
    end;

    Q^.SwapCols(i,j);
    A^.SwapRows(i,j);

    Q^.GetItem(i, i, b);
    if b < 0 then
    begin
      Q^.MultRow(i, MinusOne);
      F^.MultRow(i, MinusOne);
      Det := -Det;
    end;

    {  i- ⮫ ࠧ㥬  㫨 }
    Q^.GetItem(i, i, b);
    for ii := 1 to Q^.GetM do
      if ii <> i then
      begin
        Q^.GetItem(ii, i, b_ii);
        Alpha := lGCD(b, b_ii);
        b_i := b div Alpha;
        b_ii := -b_ii div Alpha;
        Q^.MultRow(ii, b_i);
        Q^.AddRow(ii, i, b_ii);
        F^.MultRow(ii, b_i);
        F^.AddRow(ii, i, b_ii);
        Det := Det div b_i;

        Alpha := lGCD(vGCD(Q^.GetRow(ii), M), vGCD(F^.GetRow(ii), N));
        Q^.DivRow(ii, Alpha);
        F^.DivRow(ii, Alpha);
      end;

    Inc(i); { ப}
  end;
end;

end.
