unit GL;
interface

const
  MouseDown = 0;
  RightMouseDown = 1;
  KeyDown = 2;

  Black = 0;
  Blue = 1;
  Green = 2;
  Cyan = 3;
  Red = 4;
  Magenta = 5;
  Brown = 6;
  LightGray = 7;

  DarkGray = 8;
  LightBlue = 9;
  LightGreen = 10;
  LightCyan = 11;
  LightRed = 12;
  LightMagenta = 13;
  Yellow = 14;
  White = 15;


type
  TEvent = record
    What: Byte;
    case Byte of
      MouseDown {or RightMouseDown}: (X, Y: Real);
      KeyDown: (Key: Char);
    end;

type
  TCharSet = Set of char;

procedure GraphInit;
procedure Limits(AXminUs, AYminUs, AXmaxUs, AYmaxUs: real; Equal: boolean; Margins: Boolean);
procedure LimitsAndMargins(AXminUs, AYminUs, AXmaxUs, AYmaxUs: real; Equal: boolean; XMarg, YMarg: integer);

procedure GraphDone;
procedure Clear;

procedure Axis(XUs,YUs, XDelta, YDelta: Real; MedNumberX, MedNumberY: integer);
procedure Grid(XUs, YUs, XDelta, YDelta: Real);

procedure Title(Str: String);
procedure TitleBottom(Str: String);

procedure Move(XUs, YUs: real);
procedure Draw(XUs, YUs: real);
procedure Plot(X0, Y0, X1, Y1: real); {Line}
procedure Point(Radius: Integer; Filled: Boolean);
procedure Box(X0, Y0, X1, Y1: Real; Filled: Boolean);
procedure Poly(Points: Array of real; Filled: Boolean);
(*
procedure Fill3(X0, Y0, X1, Y1, X2, Y2: Real);
procedure Fill4(X0, Y0, X1, Y1, X2, Y2, X3, Y3: Real);
procedure Fill5(X0, Y0, X1, Y1, X2, Y2, X3, Y3, X4, Y4: Real);
procedure Fill6(X0, Y0, X1, Y1, X2, Y2, X3, Y3, X4, Y4, X5, Y5: Real);
procedure Fill7(X0, Y0, X1, Y1, X2, Y2, X3, Y3, X4, Y4, X5, Y5, X6, Y6: Real);
procedure Fill8(X0, Y0, X1, Y1, X2, Y2, X3, Y3, X4, Y4, X5, Y5, X6, Y6, X7, Y7: Real);
procedure Fill9(X0, Y0, X1, Y1, X2, Y2, X3, Y3, X4, Y4, X5, Y5, X6, Y6, X7, Y7, X8, Y8: Real);
procedure Fill10(X0, Y0, X1, Y1, X2, Y2, X3, Y3, X4, Y4, X5, Y5, X6, Y6, X7, Y7, X8, Y8, X9, Y9: Real);
// 騥 楤  㦭 ( 짮 Draw):
procedure Plot3(X0, Y0, X1, Y1, X2, Y2: Real);
procedure Plot4(X0, Y0, X1, Y1, X2, Y2, X3, Y3: Real);
procedure Plot5(X0, Y0, X1, Y1, X2, Y2, X3, Y3, X4, Y4: Real);
procedure Plot6(X0, Y0, X1, Y1, X2, Y2, X3, Y3, X4, Y4, X5, Y5: Real);
procedure Plot7(X0, Y0, X1, Y1, X2, Y2, X3, Y3, X4, Y4, X5, Y5, X6, Y6: Real);
procedure Plot8(X0, Y0, X1, Y1, X2, Y2, X3, Y3, X4, Y4, X5, Y5, X6, Y6, X7, Y7: Real);
procedure Plot9(X0, Y0, X1, Y1, X2, Y2, X3, Y3, X4, Y4, X5, Y5, X6, Y6, X7, Y7, X8, Y8: Real);
procedure Plot10(X0, Y0, X1, Y1, X2, Y2, X3, Y3, X4, Y4, X5, Y5, X6, Y6, X7, Y7, X8, Y8, X9, Y9: Real);
*)
procedure LineByEquation(A, B, C: Real);
procedure GLText(Str: String);
procedure GLTextSp(XSp, YSp: byte);

procedure ThinLines;
procedure ThickLines;
procedure SolidLines;
procedure DashedLines;
procedure DottedLines;
procedure CenterLines;
procedure Color(C: Word);
procedure BkColor(C: Word);

function Long2Str(A: LongInt; Width: Byte): String;
function Real2Str(A: Real; Width, Decimals: Byte): String;
function Boolean2Str(A: Boolean): String;

procedure MouseOn;
procedure MouseOff;
procedure WaitEvent(var Event: TEvent);
procedure Wait(KeySet: TCharSet);

implementation
uses Graph, WinCRT, WinMouse, Dos;

var
  YMargin: integer;
  XMargin: integer;
  ArrowLength: integer; { 10}
  LegendHeight: integer;
  //MouseInstalled: Boolean;

var
  XFact, YFact, XminUs, YminUs, XmaxUs, YmaxUs: real;
  XMax, YMax: Integer;
  GLTextSpX, GLTextSpY: Byte;

function RX(X: Integer): Real;
begin
  RX := (X - XMargin) / XFact + XminUs;
end;

function RY(Y: Integer): Real;
begin
  RY := (YMax - YMargin - Y) / YFact + YMinUs;
end;


procedure MouseInit;{(XLo, YLo, XHi, YHi: Integer);}
begin
  InitMouse;
end;

procedure MouseOn;
begin
  ShowMouse;
end;

procedure MouseOff;
begin
  HideMouse;
end;

procedure WaitEvent(var Event: TEvent);
var MouseX, MouseY, MouseState: LongInt;
begin
  while true do
  begin
    if KeyPressed then
    begin
      Event.What := KeyDown;
      Event.Key := ReadKey;
      Exit;
    end
    else
    begin
      if LPressed then
      begin
        while LPressed do;
        GetMouseState(MouseX, MouseY, MouseState);
        Event.What := MouseDown;
        Event.X := RX(MouseX);
        Event.Y := RY(MouseY);
        Exit;
      end;
      if RPressed then
      begin
        while RPressed do;
        GetMouseState(MouseX, MouseY, MouseState);
        Event.What := RightMouseDown;
        Event.X := RX(MouseX);
        Event.Y := RY(MouseY);
        Exit;
      end;
    end;
  end;
end;

procedure Wait(KeySet: TCharSet);
var Event: TEvent;
begin
  repeat
    WaitEvent(Event);
  until (Event.What = KeyDown) and (Event.Key in KeySet);
end;

procedure GraphInit;
var
 grDriver, grMode, ErrCode: Integer;
begin
  grDriver := Detect;
  InitGraph(grDriver, grMode, '');
  ErrCode := GraphResult;
  if ErrCode <> grOk then
  begin
    Writeln('Graphics error:', GraphErrorMsg(ErrCode));
    Halt(1);
  end;

  // MouseInstalled := false;
  MouseInit;{(0, 0, XMax, YMax);}

  LimitsAndMargins(0, 0, 1000, 700, False, 0, 0);
end;

procedure Limits(AXminUs, AYminUs, AXmaxUs, AYmaxUs: real; Equal: boolean;
  Margins: Boolean);
begin
  if Margins then
    LimitsAndMargins(AXminUs, AYminUs, AXmaxUs, AYmaxUs, Equal, 50, 60)
  else
    LimitsAndMargins(AXminUs, AYminUs, AXmaxUs, AYmaxUs, Equal, 0, 0);
end;

procedure LimitsAndMargins(AXminUs, AYminUs, AXmaxUs, AYmaxUs: real; Equal: boolean;
  XMarg, YMarg: integer);
begin
  XMargin := XMarg;
  YMargin := YMarg;
  ArrowLength := 11; { 10}
  LegendHeight := 40;

  (*
  YMargin := 30;
  XMargin := 30;
  ArrowLength := 11; { 10}
  LegendHeight := 18;
  MouseInstalled := false;
  *)

  XminUs := AXminUs;
  YminUs := AYminUs;
  XmaxUs := AXmaxUs;
  YmaxUs := AYmaxUs;

  XMax := GetMaxX;
  YMax := GetMaxY;

  XFact := (XMax - 2*XMargin)/(XMaxUs - XMinUs);
  YFact := (Ymax - 2*Ymargin)/(YmaxUs - YMinUs);
  if Equal then
    if XFact > YFact then
    begin
      XFact := YFact;
      XMargin := (XMax - Round((XMaxUs - XMinUs)*XFact)) div 2;
    end
    else
    begin
      YFact := XFact;
      YMargin := (YMax - Round((YMaxUs - YMinUs)*YFact)) div 2;
    end;
    {if XFact > YFact then
    begin
      XFact := YFact;
      DeltaX := Xmax - 2*Xmargin;
      Med := (XminUs + XmaxUs)/2;
      XminUs := Med - DeltaX/2/XFact;
      XmaxUs := Med + DeltaX/2/XFact;
    end
    else
    begin
      YFact := XFact;
      DeltaY := Ymax - 2*Ymargin;
      Med := (YminUs + YmaxUs)/2;
      YminUs := Med - DeltaY/2/YFact;
      YmaxUs := Med + DeltaY/2/YFact;
    end;}


  SetTextJustify(CenterText, CenterText);
  {!!!!}
  {SetTextStyle(TriplexFont, HorizDir, 3);}
  SetTextStyle(DefaultFont, HorizDir, 1);
  {SetTextStyle(SansSerifFont, HorizDir, 1);}
  {SetTextStyle(TriplexFont, HorizDir, 1);}
  {SetTextStyle(SansSerifFont, HorizDir, 1);}

  GLTextSpX := 0;
  GLTextSpY := 0;

  ThinLines;
  SolidLines;
  Color(White);
end;

procedure GraphDone;
begin
  CloseGraph;
end;

procedure Clear;
begin
  ClearDevice;
end;


procedure Title(Str: String);
begin

  SetViewPort(0, 0, XMax, YMargin - ArrowLength, ClipOn);
  ClearViewPort;
  OutTextXY(XMax div 2, (YMargin - ArrowLength) div 2, Str);
  SetViewPort(0,0,XMax,YMax, ClipOn);

end;

procedure TitleBottom(Str: String);
begin

  SetViewPort(0, YMax - YMargin + LegendHeight, XMax, YMax, ClipOn);
  ClearViewPort;
  OutTextXY(XMax div 2, (YMargin - LegendHeight) div 2, Str);
  SetViewPort(0,0,XMax,YMax, ClipOn);

end;

function IX(XUs: Real): Integer;
begin
  IX := Round(Xmargin + (XUs - XminUs) * XFact);
end;

function IY(YUs: Real): Integer;
begin
  IY := Round(Ymax - Ymargin - (YUs - YminUs) * YFact);
end;

procedure Move(XUs, YUs: real);
begin
  MoveTo(IX(XUs), IY(YUs));
end;

procedure Draw(XUs, YUs: real);
begin
  LineTo(IX(XUs), IY(YUs));
end;

procedure Plot(X0, Y0, X1, Y1: real);
begin
  Move(X0, Y0);
  Draw(X1, Y1);
end;

procedure ThinLines;
var
  OldStyle: LineSettingsType;
begin
  GetLineSettings(OldStyle);
  with OldStyle do
    SetLineStyle(LineStyle, Pattern, NormWidth);
end;

procedure ThickLines;
var
  OldStyle: LineSettingsType;
begin
  GetLineSettings(OldStyle);
  with OldStyle do
    SetLineStyle(LineStyle, Pattern, ThickWidth);
end;

procedure SolidLines;
var
  OldStyle: LineSettingsType;
begin
  GetLineSettings(OldStyle);
  with OldStyle do
    SetLineStyle(SolidLn, Pattern, Thickness);
end;

procedure DashedLines;
var
  OldStyle: LineSettingsType;
begin
  GetLineSettings(OldStyle);
  with OldStyle do
    SetLineStyle(DashedLn, Pattern, Thickness);
end;

procedure DottedLines;
var
  OldStyle: LineSettingsType;
begin
  GetLineSettings(OldStyle);
  with OldStyle do
    SetLineStyle(DottedLn, Pattern, Thickness);
end;

procedure CenterLines;
var
  OldStyle: LineSettingsType;
begin
  GetLineSettings(OldStyle);
  with OldStyle do
    SetLineStyle(CenterLn, Pattern, Thickness);
end;

procedure Color(C: Word);
var FillInfo: FillSettingsType;
begin
  SetColor(C);
  GetFillSettings(FillInfo);
  SetFillStyle(FillInfo.Pattern, C); {࠭ Pattern, ⠭ 梥}
end;

procedure BkColor(C: Word);
begin
  SetBkColor(C);
end;

procedure Point(Radius: Integer; Filled: Boolean);
var X, Y: integer;
begin
  X := GetX; Y := GetY;
  if Filled then
    FillEllipse(X, Y, Radius, Radius)
  else
    Circle(X, Y, Radius);
end;

procedure Box(X0, Y0, X1, Y1: Real; Filled: Boolean);
begin
  if Filled then
    Bar(IX(X0), IY(Y0), IX(X1), IY(Y1))
  else
    Rectangle(IX(X0), IY(Y0), IX(X1), IY(Y1));
end;

procedure Poly(Points: array of real; Filled: Boolean);
var
  n, m, i: Integer;
  IPoints: ^PointType;
begin
  m := Length(Points);
  n := m div 2;
  GetMem(IPoints, n* SizeOf(PointType));
  for i := 0 to n - 1 do
  begin
    IPoints[i].x := IX(Points[2*i]);
    IPoints[i].y := IY(Points[2*i + 1]);
  end;
  if Filled then
    FillPoly(n, IPoints^)
  else
    DrawPoly(n, IPoints^);
end;

procedure LineByEquation(A, B, C: Real);
{  Ax + By = C}
var
  i: Integer;
  Points: array[1..4, 1..2] of Real;
  Flag: Boolean;
begin
  if A = 0 then
  begin
    Move(XMinUs, C/B); Draw(XMaxUs, C/B);
  end
  else
  if B = 0 then
  begin
    Move(C/A, YMaxUs); Draw(C/A, YMinUs);
  end
  else
  begin
    Points[1, 1] := XMinUs;
    Points[1, 2] := (C - A * XMinUs) / B;

    Points[2, 1] := XMaxUs;
    Points[2, 2] := (C - A * XMaxUs) / B;

    Points[3, 1] := (C - B * YMinUs) / A;
    Points[3, 2] := YMinUs;

    Points[4, 1] := (C - B * YMaxUs) / A;
    Points[4, 2] := YMaxUs;

    Flag := False; { 諨   אַ}
    for i := 1 to 4 do
      if (Points[i, 1] >= XMinUs) and (Points[i, 1] <= XMaxUs) and
        (Points[i, 2] >= YMinUs) and (Points[i, 2] <= YMaxUs) then
      begin
        if Flag then
          Draw(Points[i, 1], Points[i, 2])
        else
          Move(Points[i, 1], Points[i, 2]);
        Flag := true;
      end;
  end;
end;

function Long2Str(A: LongInt; Width: Byte): String;
var S: String;
begin
  Str(A: Width, S);
  Long2Str := S;
end;

function Real2Str(A: Real; Width, Decimals: Byte): String;
var S: String;
begin
  Str(A: Width: Decimals, S);
  Real2Str := S;
end;

function Boolean2Str(A: Boolean): String;
begin
  if A then Boolean2Str := 'True'
  else Boolean2Str := 'False'
end;

procedure GLText(Str: String);
var
  Style: TextSettingsType;
  X, Y: Integer;
begin
  X := GetX; Y := GetY;
  GetTextSettings(Style);
  OutTextXY(X - (Style.Horiz - 1) * GLTextSpX * Style.CharSize,
    Y + (Style.Vert - 1) * GLTextSpY * Style.CharSize, Str);
  MoveTo(X, Y);
end;

procedure GLTextSp(XSp, YSp: byte);
begin
  GLTextSpX := XSp;
  GLTextSpY := YSp;
end;

procedure Axis(XUs,YUs, XDelta,YDelta: Real; MedNumberX, MedNumberY: integer);
var
  XC, YC, XT, YT, j: Integer;
  X, Y, SmallStepX, SmallStepY: Real;
  Arrow: Array[0..3] of PointType;
begin
  XC := IX(XUs); YC := IY(YUs);

  {Lines}
  Line(XMargin - ArrowLength, YC, Xmax - XMargin + ArrowLength, YC);
  Line(XC, YMargin - ArrowLength, XC, Ymax - Ymargin + ArrowLength);

  {Arrows}
  Arrow[0].X := Xmax - XMargin + ArrowLength; Arrow[0].Y := YC;
  Arrow[1].X := Arrow[0].X - 10; Arrow[1].Y := Arrow[0].Y + 3;
  Arrow[2].X := Arrow[0].X - 10; Arrow[2].Y := Arrow[0].Y - 3;
  Arrow[3].X := Arrow[0].X; Arrow[3].Y := Arrow[0].Y;
  FillPoly(4, Arrow);

  Arrow[0].X := XC; Arrow[0].Y := YMargin - ArrowLength;
  Arrow[1].X := Arrow[0].X + 3; Arrow[1].Y := Arrow[0].Y + 10;
  Arrow[2].X := Arrow[0].X - 3; Arrow[2].Y := Arrow[0].Y + 10;
  Arrow[3].X := Arrow[0].X; Arrow[3].Y := Arrow[0].Y;
  FillPoly(4, Arrow);


  {窨}
  SmallStepX := XDelta / MedNumberX;
  x := XUs + XDelta;
  SetTextJustify(CenterText, TopText);
  while X <= XmaxUs do
  begin
    XT := IX(X);
    line(XT, YC - 5, XT, YC + 5);
    MoveTo(XT, YC + 9); GLText(Real2Str(X,0,0));
    for j := 1 to MedNumberX - 1 do
      Line(IX(X - j * SmallStepX), YC - 2, IX(X - j * SmallStepX), YC + 2);
    X := X + XDelta;
  end;

  X := XUs - XDelta;
  while X >= XMinUs do
  begin
    XT := IX(X);
    line(XT, YC - 5, XT, YC + 5);
    MoveTo(XT, YC + 9); GLText(Real2Str(X,0,0));
    for j := 1 to MedNumberX - 1 do
      Line(IX(X + j * SmallStepX), YC - 2, IX(X + j * SmallStepX), YC + 2);
    X := X - XDelta;
  end;

  SmallStepY := YDelta / MedNumberY;
  SetTextJustify(RightText, CenterText);
  Y := YUs + YDelta;
  while Y <= YmaxUs do
  begin
    YT := IY(Y);
    Line(XC - 5, YT, XC + 5, YT);
    MoveTo(XC - 9, YT); GLText(Real2Str(Y,0,0));
    for j := 1 to MedNumberY - 1 do
      Line(XC - 3, IY(Y - j * SmallStepY), XC + 3, IY(Y - j * SmallStepY));
    Y := Y + XDelta;
  end;

  Y := YUs - YDelta;
  while Y >= YminUs do
  begin
    YT := IY(Y);
    Line(XC - 5, YT, XC + 5, YT);
    MoveTo(XC - 9, YT); GLText(Real2Str(Y,0,0));
    for j := 1 to MedNumberY - 1 do
      Line(XC - 3, IY(Y + j * SmallStepY), XC + 3, IY(Y + j * SmallStepY));
    Y := Y - XDelta;
  end;

  SetTextJustify(RightText, BottomText);
  MoveTo(XC - 9, YC - 5); GLText(Real2Str(YUs,0,0));
  SetTextJustify(LeftText, TopText);
  MoveTo(XC + 5, YC + 9); GLText(Real2Str(XUs,0,0));

  SetTextJustify(CenterText, CenterText);


end;

procedure Grid(XUs, YUs, XDelta,YDelta: Real);
var XBegin, YBegin, XEnd, YEnd, i, j: Integer;
begin
  Axis(XUs, YUs, XDelta, YDelta, 1, 1);
  XBegin := Trunc(XMinUs); XEnd := Trunc(XMaxUs);
  YBegin := Trunc(YMinUs); YEnd := Trunc(YMaxUs);
  for i := XBegin to XEnd do
    for j := YBegin to YEnd do
    begin
      Move(i,j); Point(1,true);
    end;
end;

end.
