Program GraphDemo;

uses GL, WinCrt, graph;

procedure DoGasket(n: integer; Ax, Ay, Bx, By, Cx, Cy: real);
begin
    if n = 0 then
    begin
        Plot(Ax, Ay, Bx, By);
        Plot(Bx, By, Cx, Cy);
        Plot(Cx, Cy, Ax, Ay);
    end
    else
    begin
        DoGasket(n - 1, Ax, Ay, (Ax + Bx)/2, (Ay + By)/2, (Ax + Cx)/2, (Ay + Cy)/2);
        DoGasket(n - 1, Bx, By, (Bx + Ax)/2, (By + Ay)/2, (Bx + Cx)/2, (By + Cy)/2);
        DoGasket(n - 1, Cx, Cy, (Cx + Ax)/2, (Cy + Ay)/2, (Cx + Bx)/2, (Cy + By)/2);
    end;
end;

var n: Integer;

begin
    GraphInit;
    Limits(0, 0, 1, 1, True, True);
    Title('Sierpinski gasket');
    TitleBottom('Press [enter] to continue');
    Color(Green);
    for n := 1 to 6 do
    begin
        DoGasket(n, 0, 0, 1, 0, 1/2, sqrt(3)/2);
        Wait([char(13), char(11)]);
        Clear;
    end;
    GraphDone;
end.


