Program GraphDemo;

uses GL, WinCrt, Graph;

var
    i, j: word;
    Points: array of real;

begin
    GraphInit;

    Limits(0, 0, 1, 8, False, True);
    Title('Lines');
    TitleBottom('Press [enter] to continue');
    ThinLines; Color(Cyan);
    SolidLines; Plot(0, 0, 1, 0);
    DashedLines; Plot(0, 1, 1, 1);
    DottedLines; Plot(0, 2, 1, 2);
    CenterLines; Plot(0, 3, 1, 3);
    ThickLines; Color(White);
    SolidLines; Plot(0, 4, 1, 4);
    DashedLines; Plot(0, 5, 1, 5);
    DottedLines; Plot(0, 6, 1, 6);
    CenterLines; Plot(0, 7, 1, 7);
    Wait([char(13), char(11)]);
    Clear;

    Limits(-1, -1, 1, 1, True, True);
    Title('Polygones');
    TitleBottom('Press [enter] to continue');
    SetLength(Points, 10);
    Points[0] := 0; Points[1] := 1;
    Points[2] := -cos(3*pi/10); Points[3] := -sin(3*pi/10);
    Points[4] :=  cos(pi/10);   Points[5] :=  sin(pi/10);
    Points[6] := -cos(pi/10);   Points[7] :=  sin(pi/10);
    Points[8] :=  cos(3*pi/10); Points[9] := -sin(3*pi/10);
    Color(43);
    Poly(Points, True);
    Wait([char(13), char(11)]);
    Clear;

    Limits(0, 0, 16, 16, False, False);
    for i := 0 to 15 do
        for j := 0 to 15 do
        begin
            Color(j*16 + i);
            Box(j, i, j + 1, i + 1, True);
        end;
    Wait([char(13), char(11)]);
    Clear;

    Limits(0, 0, 10, 12, False, False);
    SetTextStyle(DefaultFont, HorizDir, 1); Move(5, 11);
    GLText('Default Font');
    SetTextStyle(TriplexFont, HorizDir, 4); Move(5, 10);
    GLText('Triplex Font');
    SetTextStyle(SmallFont, HorizDir, 4); Move(5, 9);
    GLText('Small Font');
    SetTextStyle(SansSerifFont, HorizDir, 4); Move(5, 8);
    GLText('Sans Serif Font');
    SetTextStyle(GothicFont, HorizDir, 4); Move(5, 7);
    GLText('Gothic Font');
    SetTextStyle(SimpleFont, HorizDir, 4); Move(5, 6);
    GLText('Simple Font');
    SetTextStyle(ScriptFont, HorizDir, 4); Move(5, 5);
    GLText('Script Font');
    SetTextStyle(EuroFont, HorizDir, 4); Move(5, 4);
    GLText('Euro Font');
    SetTextStyle(BoldFont, HorizDir, 4); Move(5, 3);
    GLText('Bold Font');
    SetTextStyle(TSCRFont, HorizDir, 4); Move(5, 2);
    GLText('TSCR Font');
    SetTextStyle(LCOMFont, HorizDir, 4); Move(5, 1);
    GLText('LCOM Font');
    SetTextStyle(SimpleFont, VertDir, 5); Move(1, 6);
    GLText('Vertical direction text');

    Wait([char(13), char(11)]);
    Clear;

    GraphDone;
end.


