program OstowFl(input,output);
uses Strcts, Motzkin, DOS;

function FileExist(FileName : string) : byte;
var DirInfo : SearchRec;
begin
  FindFirst(FileName, Archive, DirInfo);
  FileExist := DosError;
end;

var
  IneFileName, ExtFileName, BasFileName, IncFileName, LogFileName: String;
  IneFile, ExtFile, BasFile, IncFile, LogFile: Text;
  Ine, Ext, Bas, Inc: PLongMatrix;
  M, N: Integer;
  det: LongInt;
  Modification: Byte;
  Code: Integer;
  Dir: DirStr;
  Name: NameStr;
  Exten: ExtStr;
begin
  {if ParamCount < 1 then
  begin
    writeln('Usage: ostowfl <inputfilename> [<outputfilename1> [<outputfilename2> [<modification>]]]');
    Exit;
  end;}

  IneFileName := paramstr(1);

  if ParamCount < 2 then
  begin
    FSplit(IneFileName, Dir, Name, Exten);
    if Exten = '.ext' then Exten := '.ine' else Exten := '.ext';
    ExtFileName := Dir + Name + Exten;
  end
  else
    ExtFileName := paramstr(2);

  if ParamCount < 3 then
  begin
    if Exten = '.ext' then Exten := '.inf' else Exten := '.bas';
    BasFileName := Dir + Name + Exten;
  end
  else
    BasFileName := paramstr(3);

  IncFileName := Dir + Name + '.inc';
  LogFileName := Dir + Name + '.log';

  if ParamCount < 4 then
    Modification := 1
  else
  begin
    Val(ParamStr(4), Modification, Code);
    if code <> 0 then
    begin
      Writeln('Error at position: ', Code);
      Modification := 0
    end
  end;

  if FileExist(IneFileName) <> 0 then
  begin
    Writeln('Error: File ', IneFileName, ' not found');
    Exit;
  end;

  Assign(IneFile, IneFileName);
  Reset(IneFile);
  Readln(IneFile, M, N);
  if (M <= 0) or (N <= 0) then
  begin
    Writeln('Invalid parameters');
    Exit;
  end;
  Ine := New(PLongMatrix, Init(2, 2));
  Ext := New(PLongMatrix, Init(2, 2));
  Inc := New(PLongMatrix, Init(2, 2));
  Bas := New(PLongMatrix, Init(2, 2));
  Ine^.ReSize(M, N);
  Ine^.FromFile(IneFile);
  Close(IneFile);

  case Ostow(Ine, Ext, Inc, Bas, Modification) of {call Ostow}
    -2: Writeln(' 墠⠥ ');
    -3: Writeln(' 襭, ⫨筮  0');
    1, 2:
    begin
      Writeln('Done');

      Assign(LogFile, LogFileName);
      Rewrite(LogFile);
      Writeln(LogFile, 'm=', Ine^.GetM, '  n=', Ine^.GetN);
      Writeln(LogFile, 'k=', Ext^.GetM);
      Writeln(LogFile);
      if Bas^.GetM = 0 then
        Writeln(LogFile, '஦ ')
      else
      begin
        Writeln(LogFile, ' ஦. ࠢ:', BasFileName);
        Writeln(LogFile);
      end;
      Writeln(LogFile);
      Print3LongMatrix(LogFile, Ext, Ine, Inc);
      Close(LogFile);

      Assign(ExtFile, ExtFileName);
      Rewrite(ExtFile);
      Writeln(ExtFile, Ext^.GetM, ' ', Ext^.GetN);
      Ext^.ToFile(ExtFile);
      Close(ExtFile);

      Assign(BasFile, BasFileName);
      Rewrite(BasFile);
      Writeln(BasFile, Bas^.M, ' ', Bas^.N);
      Bas^.ToFile(BasFile);
      Close(BasFile);

      Assign(IncFile, IncFileName);
      Rewrite(IncFile);
      Writeln(IncFile, Inc^.M, ' ', Inc^.N);
      Inc^.ToFile(IncFile);
      Close(IncFile);
    end;
  end; { case Ostow }

  Dispose(Ine, Done);
  Dispose(Ext, Done);
  Dispose(Inc, Done);
  Dispose(Bas, Done);
end.
