unit system2d;
Interface

const MaxM = 1000;

type Matrix = array[1..MaxM][0..2] of real;

function LinearInequalitiesSystem(M: Integer; A: matrix; var B: matrix):
  integer;
{
  Return values:
     1
     2
    -2 out of memory
    -3 no solution
}

Implementation

uses Strcts, Motzkin;

const N = 3;

function MaxItemInRow(const var A: matrix; I: Integer): Real;
var
  J: Integer;
  Max: Real;
begin
  Max := 0;
  for J := 0 to N - 1 do
    if Abs(A[i][j]) > Max then
      Max := Abs(A[i][j]);
end;

function LinearInequalitiesSystem
  (M: Integer; const var A: matrix; var K: Integer; var B: matrix): integer;

var
  Ine, Ext, Bas, Inc: PLongMatrix;
  N, i, j: Integer;
  Item: LongInt;
  Modification: Byte;

begin

  Ine := New(PLongMatrix, Init(M, N));
  Ext := New(PLongMatrix, Init(2, 2));
  Inc := New(PLongMatrix, Init(2, 2));
  Bas := New(PLongMatrix, Init(2, 2));

  for i := 1 to M do
  begin
    MaxItem := MaxItemInRow(A, i);
    for j := 1 to N - 1 do
    begin
      Item := Round(A[i][j] / MaxItem * 1000);
      Ine^.PutItem(i, j, Item);
    end;
    Item := Round(A[i][0] / MaxItem * 1000);
    Ine^.PutItem(i, N, Item);
  end;


  Modification := 0;

  LinearInequalitiesSystem = Ostow(Ine, Ext, Inc, Bas, Modification);

  K = Ext^.GetM;
  for i := 1 to K do
  begin
    Ext^.GetItem(i, N, Item0);
    B[i][0] := Item0;
    for j := 1 to N - 1 do
    begin
      Ext^.GetItem(i, j, Item);
      if Item0 = 0 then
        B[i][j] := Item;
      else
        B[i][j] := Item / Item0;
    end;
  end;

  Dispose(Ine, Done);
  Dispose(Ext, Done);
  Dispose(Inc, Done);
  Dispose(Bas, Done);
end.
