Unit SystemP;
Interface

procedure MovePointer(var P: pointer; Count: Word);
  { 楤 "।" 㪠⥫ P  Count  "।" }

function GetMem(Size: Word): Pointer;

function Long2String(L: LongInt; Len: Byte): String;
 { 뤠 ப, ᮮ. L  Len }

function Str2Real(S : string; var R : Real) : Boolean;
  {-Convert a string to a real, returning true if successful}

function Real2Str(R : Real; Width, Places : Byte) : string;
  {-Convert a real to a string}

function GetEmptyString(len: byte): string;

function FillString(Ch: Char; len: byte): string;

function Sign(var a: LongInt): Integer;

{function Val(L: LongInt): String; assembler;}

Implementation
type
  ByteArray = array[0..$FFFF-1] of byte;

procedure MovePointer(var P: pointer; Count: Word);
begin
  P := @(ByteArray(P^)[Count]);
end;

function GetMem(Size: Word): Pointer;
var P: Pointer;
begin
  System.GetMem(P, Size);
  GetMem := P;
end;

{**************************}
{*       Long2String      *}
{**************************}

function LeftPadCh(S : string; Ch : Char; Len : Byte) : string;
  {-Return a string left-padded to length len with ch}
var
  o : string;
  SLen : Byte absolute S;
begin
  if Length(S) >= Len then
    LeftPadCh := S
  else if SLen < 255 then begin
    o[0] := Chr(Len);
    Move(S[1], o[Succ(Word(Len))-SLen], SLen);
    FillChar(o[1], Len-SLen, Ch);
    LeftPadCh := o;
  end;
end;

function LeftPad(S : string; Len : Byte) : string;
  {-Return a string left-padded to length len with blanks}
begin
  LeftPad := LeftPadCh(S, ' ', Len);
end;

function Long2String(L: LongInt; Len: Byte): String;
var o: String;
begin
  Str(L: Len, o);
  if Length(o) > Len then
    if L < 0 then FillChar(o[1], Len, '-')
    else FillChar(o[1], Len, '+');
  o[0] := Char(Len);
  Long2String := o;
end;

function GetEmptyString(len: byte): string;
var
  Str: String;
  i: Integer;
begin
  GetEmptyString := FillString(' ', len);
end;

function FillString(Ch: Char; len: byte): string;
var
  Str: String;
  i: Integer;
begin
  Str[0] := Char(len);
  for i := 1 to len do
    Str[i] := Ch;
  FillString := Str;
end;

function Sign(var a: LongInt): Integer;
begin
  if a > 0 then
    Sign := 1
  else
    if a = 0 then
      Sign := 0
    else
      Sign := -1
end;

function Str2Real(S : string; var R : Real) : Boolean;
  {-Convert a string to a real, returning true if successful}
var
  Code, I : Word;
  SLen : Byte absolute S;
begin
  {$IFDEF Ver40}
  S := Trim(S);
  {deal with 4.0 problem of a decimal point with no digit to the left/right}
  if SLen > 0 then begin
    if S[SLen] = '.' then begin
      Inc(SLen);
      S[SLen] := '0';
    end;
    case S[1] of
      '.' : Insert('0', S, 1);
      '-',
      '+' : if (SLen > 1) and (S[2] = '.') then
              Insert('0', S, 2);
      else begin
        I := Pos('.', S);
        if I = 0 then
          S := S+'.0';
      end;
    end;
  end;
  {$ELSE}
  while S[SLen] = ' ' do
    Dec(SLen);
  {$ENDIF}

  Val(S, R, Code);
  if Code <> 0 then begin
    R := Code;
    Str2Real := False;
  end else
    Str2Real := True;
end;

function Real2Str(R : Real; Width, Places : Byte) : string;
  {-Convert a real to a string}
var
  S : string;
begin
  Str(R:Width:Places, S);
  Real2Str := S;
end;


(*function Val(L: LongInt): String; assembler;
{
; Convert next parameter to string
; In	AL    = Conversion character
; Out	DS:SI = Pointer to string
;	CX    = String length
}
var w: record
      l: word;
      h: word;
      end absolute a;
asm
Convert:
asm
        MOV       BX, W.H
        MOV       AX, W.L

	MOV	CL,10
	OR	BX,BX
	JNS	ConvertNum
	NEG	BX
	NEG	AX
	SBB	BX,0
	CALL	ConvertNum
	MOV	AL,'-'

ConvertNum:

	PUSH	SI
@@1:	XOR	DX,DX
	XCHG	AX,BX
	DIV	CX
	XCHG	AX,BX
	DIV	CX
	ADD	DL,'0'
	DEC	SI
	MOV	[SI],DL
	MOV	DX,AX
	OR	DX,BX
	JNE	@@1
	POP	CX
	SUB	CX,SI
	RET*)
end.