Program Sierpinski;

uses GL, WinCrt, graph;

var
    a, b: real;
    CurX, CurY: real;

procedure Step (dx, dy: Real);
begin
    CurX := CurX + dx;
    CurY := CurY + dy;
    Draw(CurX, CurY);
end;

procedure AA(k: integer); forward;
procedure BB(k: integer); forward;
procedure CC(k: integer); forward;
procedure DD(k: integer); forward;

procedure AA(k: integer);
begin
   if k > 0 then
   begin
       AA(k - 1); Step(a, b);
       BB(k - 1); Step(a, 0);
       DD(k - 1); Step(a,-b);
       AA(k - 1);
   end;
end;

procedure BB(k: integer);
begin
   if k > 0 then
   begin
       BB(k - 1); Step(-a, b);
       CC(k - 1); Step(0, b);
       AA(k - 1); Step(a, b);
       BB(k - 1);
   end;
end;

procedure CC(k: integer);
begin
   if k > 0 then
   begin
       CC(k - 1); Step(-a, -b);
       DD(k - 1); Step(-a, 0);
       BB(k - 1); Step(-a, b);
       CC(k - 1);
   end;
end;

procedure DD(k: integer);
begin
   if k>0 then
   begin
       DD(k - 1); Step(a, -b);
       AA(k - 1); Step(0, -b);
       CC(k - 1); Step(-a, -b);
       DD(k - 1);
   end;
end;

var
    W, H: Real;
    n: integer;

begin
    a := 1;
    b := a;

    GraphInit;
    for n := 1 to 6 do
    begin
        W := exp((n - 1)*ln(2))*(5*a + 1) - 1;
        H := exp((n - 1)*ln(2))*(5*b + 1) - 1;
        Limits(0, 0, W, H, True, True);
        //Box(0, 0, W, H, False);
        Title('Sierpinski carpet');

        Color(LightBlue);
        CurX := a;
        CurY := 0;
        Move(CurX, CurY);
        AA(N); Step(a, b);
        BB(N); Step(-a, b);
        CC(N); Step(-a, -b);
        DD(N); Step(a, -b);

        Color(White);
        TitleBottom('Press [Enter] for continue');
        Wait([char(13)]);
        Clear;
    end;
    GraphDone;
end.


